import time

# TODO define runBoard and other functions.
def loadBoard(filepath):
    with open(filepath, 'r') as boggleFile:
        board = [line.strip().split() for line in boggleFile.readlines()]
    
    return board
    
def readDictionary(filepath):
    with open(filepath, 'r') as dictFile:
        dictionary = [word.strip() for word in dictFile.readlines()]

    return dictionary

def printBoard(board):
    print()
    for row in board:
        for element in row:
            print(element, end=" ")     
        print()                       
    print()
        
def possibleMoves(location, board):
    size = len(board)
    row = location[0]
    col = location[1]
    moves = []
    
    if row-1 >= 0:
        moves.append((row-1,col))
        if col-1 >= 0:
            moves.append((row-1,col-1))
        if col+1 < size:
            moves.append((row-1,col+1))
            
    if row+1 < size:
        moves.append((row+1,col))
        if col-1 >= 0:
            moves.append((row+1,col-1))
        if col+1 < size:
            moves.append((row+1,col+1))
    
    if col-1 >= 0:
        moves.append((row,col-1))
       
    if col+1 < size:
        moves.append((row,col+1))
        
    return moves

def legalMoves(possibleMoves, visited):
    for position in visited:
        if position in possibleMoves:
           possibleMoves.remove(position)
    
    return possibleMoves

def examineState(myBoard, currPosition, path, myDict):
    letterPath = []
    for position in path:
        letterPath.append(myBoard[position[0]][position[1]])

    letterPath.append(myBoard[currPosition[0]][currPosition[1]])
    letters = "".join(letterPath).lower()

    if letters in myDict:
        isWord = "yes"
    else:
        isWord = "no"

    return letters, isWord

def runBoard(boardFile, dictFile):
    myBoard = loadBoard(boardFile)
    myDict = readDictionary(dictFile)
    moveCount = 0
    wordList = []

    printBoard( myBoard )
    print("And we're off!\nRunning with cleverness ON")

    #################Recursive Function################
    def runBoardHelper(currentPos, path):
        nonlocal moveCount 
        moveCount += 1

        stateResult = examineState(myBoard, currentPos, path, myDict)

        #check if current word is a substring of any word in dict *lowers runtime
        aSubstringOfDict = any(stateResult[0] in word for word in myDict)   
        if not aSubstringOfDict:
            return
        
        if stateResult[1] == "yes" and stateResult[0] not in wordList:  
            wordList.append(stateResult[0])

        for position in legalMoves( possibleMoves(currentPos, myBoard), path ):
            runBoardHelper(position, path + [currentPos])
    ###################################################
    
    startTime = time.time()

    for row in range(len(myBoard)):     
        for col in range(len(myBoard)):
            runBoardHelper((row,col), [])

    endTime = time.time()
    totalTime = endTime - startTime

    print(f"Searched total of {moveCount} moves in {totalTime} seconds\n")
    print("Words found:")
    for wordLength in range(2,17):
        resultList = [word for word in wordList if len(word)==wordLength]
        if len(resultList) > 0:
            print(f"{wordLength}-letter words: {resultList}")
    print(f"\nfound {len(wordList)} words total")
    print("Alpha-Sorted List:")
    print(sorted(wordList))

runBoard( "4x4board.txt", "twl06.txt")